OPT MODULE,OSVERSION=37
OPT EXPORT,PREPROCESS,REG=5


/*
**      $VER: Msql.h 5.4 (22.08.99)
**
**      definition of Msql
**
**      (C) Copyright 1999 Christophe Sollet
**      All Rights Reserved.
**      AmigaE version by Piotr Gapiski (narg@polbox.com)
**
*/

MODULE 'exec/tasks'


OBJECT hookMessage
  id          :CHAR         ->- (unsigned) Which function was called
  type        :CHAR         ->- (unsigned) Enter the function or exit it?
  task        :PTR TO tc    ->-            The calling task
  a0,a1,a2    :LONG         ->- (unsigned) Register Contents at the function call or return
  d0,d1,d2    :LONG         ->- (unsigned)
ENDOBJECT


CONST  FCH_ENTER =  0,
       FCH_EXIT  =  1


->- Hook Function id
->-
CONST  MFT_AllocConnection = 1,
       MFT_FreeConnection  = 2,
       MFT_GetErrMsg       = 3,
       MFT_Connect         = 4,
       MFT_SelectDB        = 5,
       MFT_Query           = 6,
       MFT_CreateDB        = 7,
       MFT_DropDB          = 8,
       MFT_Shutdown        = 9,
       MFT_GetProtoInfo    = 10,
       MFT_ReloadAcls      = 11,
       MFT_GetServerInfo   = 12,
       MFT_GetHostInfo     = 13,
       MFT_Close           = 14,
       MFT_DataSeek        = 15,
       MFT_FieldSeek       = 16,
       MFT_FreeResult      = 17,
       MFT_FetchRow        = 18,
       MFT_FetchField      = 19,
       MFT_ListDBs         = 20,
       MFT_ListTables      = 21,
       MFT_ListFields      = 22,
       MFT_ListIndex       = 23,
       MFT_StoreResult     = 24,
       MFT_LoadConfigFile  = 25,
       MFT_GetIntConfOld   = 26,
       MFT_GetCharConfOld  = 27,
       MFT_GetIntConf      = 28,
       MFT_GetCharConf     = 29,
       MFT_GetServerStats  = 30,
       MFT_CopyDB          = 31,
       MFT_MoveDB          = 32,
       MFT_UnixTimeToDate  = 33,
       MFT_UnixTimeToTime  = 34,
       MFT_GetSequenceInfo = 35,
       MFT_DateToUnixTime  = 36,
       MFT_TimeToUnixTime  = 37,
       MFT_SumTimes        = 38,
       MFT_DateOffset      = 39,
       MFT_DiffTimes       = 40,
       MFT_DiffDates       = 41


OBJECT msqlConnection PRIVATE
  empty
ENDOBJECT

OBJECT m_row
  m_row       :PTR TO CHAR
ENDOBJECT

OBJECT m_field
  name        :PTR TO CHAR
  table       :PTR TO CHAR
  type        :LONG
  length      :LONG
  flags       :LONG
ENDOBJECT

OBJECT m_seq
  step        :LONG
  value       :LONG
ENDOBJECT

OBJECT m_data
  width       :LONG
  data        :PTR TO m_row  ->- char **
  next        :PTR TO m_data
ENDOBJECT

OBJECT m_fdata
   field      :m_field
   next       :PTR TO m_fdata
ENDOBJECT

OBJECT m_result
  queryData   :PTR TO m_data
  cursor      :PTR TO m_data
  fieldData   :PTR TO m_fdata
  fieldCursor :PTR TO m_fdata
  numRows     :LONG
  numFields   :LONG
ENDOBJECT

#define  MsqlNumRows(res)    res.numRows
#define  MsqlNumFields(res)  res.numFields

CONST  INT_TYPE        = 1,
       CHAR_TYPE       = 2,
       REAL_TYPE       = 3,
       IDENT_TYPE      = 4,
       NULL_TYPE       = 5,
       TEXT_TYPE       = 6,
       DATE_TYPE       = 7,
       UINT_TYPE       = 8,
       MONEY_TYPE      = 9,
       TIME_TYPE       = 10,
       LAST_REAL_TYPE  = 10,
       IDX_TYPE        = 253,
       SYSVAR_TYPE     = 254,
       ANY_TYPE        = 255

CONST  NOT_NULL_FLAG   = 1,
       UNIQUE_FLAG     = 2

#define IS_UNIQUE(n)    (n AND UNIQUE_FLAG)
#define IS_NOT_NULL(n)  (n AND NOT_NULL_FLAG)

->- [AMIGAE]
->- I don't know HOW translate following piece of code
->- static char msqlTypeNames[][12] =
->-   {
->-     "???", "int", "char","real","ident","null","text","date","uint",
->-     "money","time","???"
->-   };
->- from NOW msqlTypeNames(x) instead msqlTypeNames[x][0] MUST be used!

#define msqlTypeNames(x) ListItem(['???','int','char','real','ident','null','text','date','uint','money','time','???']:LONG,x)
