/*
**      $VER: msql_protos.h 5.4 (22.08.99)
**
**      prototypes for msql.library
**
**      (C) Copyright 1999 Christophe Sollet
**      All Rights Reserved.
*/

#ifndef CLIB_MSQL_PROTOS_H
#define CLIB_MSQL_PROTOS_H

#ifndef MSQL_MSQLBASE_H
#endif

#include <time.h>

#ifndef MSQL_MSQL_H
#include <libraries/msql.h>
#endif

struct MsqlConnection *MsqlAllocConnection(void);
void MsqlFreeConnection(struct MsqlConnection *);
char *MsqlGetErrMsg(struct MsqlConnection *);
struct MsqlConnection *MsqlConnect(struct MsqlConnection *, char *);
int	MsqlSelectDB(struct MsqlConnection *, char *);
int	MsqlQuery(struct MsqlConnection *, char *);
int	MsqlCreateDB(struct MsqlConnection *, char *);
int	MsqlDropDB(struct MsqlConnection *, char *);
int	MsqlShutdown(struct MsqlConnection *);
int	MsqlGetProtoInfo(struct MsqlConnection *);
int	MsqlReloadAcls(struct MsqlConnection *);
char *MsqlGetServerInfo(struct MsqlConnection *);
char *MsqlGetHostInfo(struct MsqlConnection *);
void MsqlClose(struct MsqlConnection *);
void MsqlDataSeek(m_result *, int);
void MsqlFieldSeek(m_result *, int);
void MsqlFreeResult(m_result *);
m_row MsqlFetchRow(m_result *);
m_field	*MsqlFetchField(m_result *);
m_result *MsqlListDBs(struct MsqlConnection *);
m_result *MsqlListTables(struct MsqlConnection *);
m_result *MsqlListFields(struct MsqlConnection *, char *);
m_result *MsqlListIndex(struct MsqlConnection *, char *, char *);
m_result *MsqlStoreResult(struct MsqlConnection *);
int MsqlLoadConfigFile(struct MsqlConnection *, char *);
int MsqlGetIntConf(struct MsqlConnection *, char *, char *);
char *MsqlGetCharConf(struct MsqlConnection *, char *, char *);
int	MsqlGetServerStats(struct MsqlConnection *, BPTR);
int	MsqlCopyDB(struct MsqlConnection *, char *, char *);
int MsqlMoveDB(struct MsqlConnection *, char *, char *);
char *MsqlUnixTimeToDate(time_t);
char *MsqlUnixTimeToTime(time_t);
m_seq *MsqlGetSequenceInfo(struct MsqlConnection *, char *);
time_t MsqlDateToUnixTime(char *);
time_t MsqlTimeToUnixTime(char *);
char *MsqlSumTimes(char *, char *);
char *MsqlDateOffset(char *, int, int, int);
char *MsqlDiffTimes(char *, char *);
int MsqlDiffDates(char *, char *);
BOOL MsqlAddMHookA(struct Hook *, struct TagList *);
void MsqlRemMHook(struct Hook *);

BOOL MsqlAddMHook(struct Hook *, ULONG, ...);

/* A connection structure was not required any more with this function */
#ifdef MSQL_OBSOLETE_PROTOS
#define MsqlDataSeek(a, b, c)	MsqlDataSeek(b, c)
#define MsqlFieldSeek(a, b, c)	MsqlFieldSeek(b , c)
#define MsqlFreeResult(a , b)	MsqlFreeResult(b)
#define MsqlFetchRow(a, b)		MsqlFetchRow(b)
#define MsqlFetchField(a, b)	MsqlFetchField(b)
#endif

#endif
